"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
module.exports = __toCommonJS(src_exports);
var import_yargs = __toESM(require("yargs"));
var import_assert = require("@code-like-a-carpenter/assert");
var import_codegen = require("./codegen");
__reExport(src_exports, require("./config"), module.exports);
(0, import_yargs.default)(process.argv.slice(2)).command(
  "codegen",
  "Generate code from a GraphQL schema",
  (y) => y.options({
    config: {
      default: ".foundationrc",
      description: "Path to the config file",
      type: "string"
    },
    outputs: {
      choices: ["cloudformation", "typescript"],
      default: ["cloudformation", "typescript"],
      description: "Output formats",
      type: "array"
    }
  }),
  ({ outputs, ...rest }) => {
    const typesafe = outputs.map((o) => {
      (0, import_assert.assert)(
        o === "cloudformation" || o === "typescript",
        `Invalid output ${o}`
      );
      return o;
    });
    return (0, import_codegen.generateCode)({ ...rest, outputs: typesafe });
  }
).help().demandCommand().argv;
